Page MenuHomePhabricator

Keyboard Module can't switch layouts with shortcut
Closed, ResolvedPublic

Description

Set Settings > All > Input> Keyboard > Options > Layout switching to Alt Shift.

It doesn't work.

ApB created this task.Jan 19 2016, 5:47 AM
ApB updated the task description. (Show Details)
ApB raised the priority of this task from to Incoming Queue.
ApB added projects: enlightenment-git, Restricted Project.
ApB added a subscriber: ApB.
zmike reassigned this task from zmike to bu5hm4n.Jan 19 2016, 8:33 AM

To elaborte here a bit: The options which are set in this pane are resulting out of x rules which are saved in a file. This options are set via the setxkbbmap with the option --option, this call does not work in wl. So in the end the keyboard shortcuts are not monitored in e - but in x. Will dig into it this week.

oz added a subscriber: oz.Feb 22 2016, 4:03 AM

This seems to work now, but there is still an inconsistency:

  • does work when having only us (default, basic) and ru (default, basic)
  • does not work when having only us (default, basic) and kr (default, basic)
  • does work when having us (default, basic), ru (default, basic) and kr (default, basic)
ApB added a comment.Mar 29 2016, 4:12 AM

Can confirm what @oz said. It works with two layouts but when you have three it changes only between the two first.

ApB added a comment.May 12 2016, 2:16 AM

Something fishy going on here. While it seems to change between layouts, if you have 3 and you remove one it you can still type characters of the layout you removed. You need to log out and log in again for the change in layouts to take effect.

Can someone confirm?

Thats something in xkbswitch will try to fix it this evening.

ApB reopened this task as Open.May 13 2016, 2:28 AM

Still something wrong with it.

I added three languages (US, Greek and Hebrew) changed between the three and after i removed hebrew i could still type them after i switched a few times with the shortcut.

ApB added a comment.May 14 2016, 11:51 AM

This also seems to have another problem.

Immediately after starting or restarting E the shortcut doesn't work. I have to change it with the mouse and then it starts to work.

Well to be honest, this looks like something unrelated to this.

When e-wl is started i am flushing out the config into the xkb lib. The config defines a set of layouts (and options, variants).

The only way the config is flushed again is the keyboard config dialog has changed the sets.

Once the set is flushed nothing ever changes that.
So if you toggle the shortcut on your keyboard its handled by libxkbcommon, NOT e, same applies for the beginning. So i am not sure where this issue is, but its unlikly to have it in e.

bu5hm4n closed this task as Resolved.Jun 24 2016, 4:27 AM

Okay this seems to be resolved.

For layouts which are not used:

  • X had the hardcoded limit of 4 layouts now xkbcommon has this too, which means this cannot be fixed in e...

Other things seems to be fixed.